---
title: Using the aria-hidden attribute
slug: Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-hidden_attribute
tags:
  - ARIA
  - Accessibility
  - Attribute
  - CodingScripting
  - HTML
  - JavaScript
  - NeedsContent
  - Role(2)
  - agent
  - alert
  - user
  - userAgent
---
<p>{{draft}}</p>

<p>This technique demonstrates how to use the <code>aria-hidden</code> attribute. The <code>aria-hidden</code> attribute can either expose or hide non-interactive content from the accessibility API. </p>

<h2 id="Description">Description</h2>

<div class="summary">
<p>Adding <code>aria-hidden="true"</code> to an element removes that element and all of its children from the accessibility tree. This can improve the experience for assistive technology users by hiding:</p>

<ul>
	<li>purely decorative content, such as icons or images</li>
	<li>duplicated content, such as repeated text</li>
	<li>offscreen or collapsed content, such as menus</li>
</ul>

<p>According to the <a href="https://www.w3.org/TR/using-aria/#fourth">fourth rule of ARIA</a>, <code>aria-hidden="true"</code> should not be used on a focusable element. Additionally, since this attribute is inherited by an element's children, it should not be added onto the parent or ancestor of a focusable element. </p>

<p>Using <code>aria-hidden="false"</code> will not re-expose the element to assistive technology if any of its parents specify <code>aria-hidden="true".</code></p>
</div>

<div class="notecard warning">
<p>WAI-ARIA Authoring Practices 1.1 notes that <code>aria-hidden="false"</code> currently <a href="https://www.w3.org/TR/wai-aria-1.1/#aria-hidden">behaves inconsistently across browsers</a>.</p>
</div>

<h3 id="Deciding_between_aria-hiddentrue_rolepresentation_and_rolenone">Deciding between <code>aria-hidden="true"</code>, <code>role="presentation"</code>, and <code>role="none"</code></h3>

<p>On the surface, the <code>aria-hidden="true"</code>, <code>role="presentation"</code>, and <code>role="none"</code> attributes seem similar because they:</p>

<ul>
	<li>hide content from assistive technology</li>
	<li>cannot be used on a focusable element</li>
	<li>cannot be used on the parent of an interactive element</li>
</ul>

<p>Despite these similarities, the intent behind each attribute is different. </p>

<ul>
	<li><code>aria-hidden="true"</code> will remove the entire element from the accessibility API. </li>
	<li><code>role="presentation"</code> and <code>role="none"</code> will remove the semantic meaning of an element while still exposing it to assistive technology. </li>
</ul>



<h3 id="Values">Values</h3>

<dl>
	<dt><code>false</code></dt>
	<dd>(default) The element is exposed to the accessibility API.</dd>
	<dt><code>true</code></dt>
	<dd>The element is not exposed to the accessibility API. </dd>
	<dt><code>undefined</code></dt>
	<dd>(default) The user agent determines if the element is exposed to or hidden from the accessibility API.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the example below, the paragraph is not exposed to the accessibility API (e.g. would not be read aloud by a screen reader).</p>

<pre class="brush: html">&lt;p aria-hidden="true"&gt;
  Some things are better left unsaid.
&lt;/p&gt;
</pre>

<p>Children elements can be omitted from accessibility APIs:</p>

<pre class="brush: html">&lt;p&gt;
  This is not hidden &lt;span aria-hidden="true"&gt;but this is&lt;/span&gt;!
&lt;/p&gt;</pre>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<h2 id="Best_practices">Best practices</h2>

<p> <code>aria-hidden="true"</code> should not be added when:</p>

<ul>
	<li>the HTML <code>hidden</code> attribute is present</li>
	<li>the element or the element's ancestor is hidden with <code>display: none</code></li>
	<li>The element or the element's ancestor is hidden with <code>visibility: hidden</code> </li>
</ul>

<p>In all three scenarios, the attribute is unnecessary to add because the element has already been removed from the accessibility tree. </p>

<h2 id="Specifications">Specifications</h2>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_presentation_role">Using the presentation role</a></li>
	<li><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_none_role">role="none"</a></li>
</ul>
